--Created: 16. junij 2000 14:18, petek
--Author: Tone koda  e-mail: tone.skoda@siol.net
--Purpose: functions for searching text in text
--All the routines in this file are
--independent, ie: they can be used in any file
--by including this file in that file.

include wildcard.e


--returns sequence
--1. position in global text where word found or 0 if not found
--2. length of found word
--arg s: here searching
--arg findtext: this text searcing, also can have wildcard
--arg from_char: from this char in s start search
global function TsSearch_FindText(sequence s,
	sequence findtext,
	integer match_whole_word,
	integer match_case,
	integer search_down, --[1(down),-1(up)]
	integer wild_card, --if wildcard match(1). if 0 then * and ? taken as litearlly
	atom from_char
	)

	atom pos
	atom prevpos
	sequence word
	sequence findtext_lower
	sequence word_lower
	sequence findtext_cmp
	sequence word_cmp
	sequence sslice
	atom foundpos --this returned, start position of word found
	atom found_len --length of found word
	sequence s_cmp

	foundpos=0
	found_len=0
	
	if wild_card then
		match_whole_word=1
	end if
	
	findtext_lower=lower(findtext)--if no case match


	if match_whole_word then
		pos=from_char-search_down
		while 1 do
			prevpos=pos+search_down			
			if prevpos<1 or prevpos>=length(s) then
				exit
			end if
			--shown("prevpos",prevpos)
			pos=TSWordGoToEdge_Eu1(s,prevpos,search_down)			
			if pos<1 or pos>=length(s)
				or prevpos<1 or prevpos>=length(s) then
				exit
			end if

			word=mid(s,
				Min(prevpos,pos),
				Max(prevpos,pos))

			--showw("word",word)

			--macth case:
			if match_case=0 then
				findtext_cmp=findtext_lower
				word_cmp=lower(word)
			else
				findtext_cmp=findtext
				word_cmp=word
			end if
			--macth case.
			

			--compare if equal:
			if wild_card then
				if wildcard_match(findtext_cmp,word_cmp) then
--					printf(1,"\n%s%s%s",{
--					findtext," is equal as(W) ",
--					word
--					})
					foundpos=Min(prevpos,pos)
					found_len=Max(prevpos,pos)-
						Min(prevpos,pos)+1
					exit
				end if
			else				
			if equal(findtext_cmp,word_cmp) then
--				printf(1,"\n%s%s%s",{
--					findtext," is equal as ",
--					word
--					})
				foundpos=Min(prevpos,pos)
				found_len=Max(prevpos,pos)-
					Min(prevpos,pos)+1
				exit
			end if
			
			end if
			--compare if equal.			
		end while

	else	--if not match whole word
		--macth case:
		if match_case=0 then
			findtext_cmp=findtext_lower
			s_cmp=lower(s)
		else
			findtext_cmp=findtext
			s_cmp=s
		end if
		--macth case.

		found_len=length(findtext_cmp)

		if search_down=1 then
			foundpos=matchfrom(findtext_cmp,s_cmp,from_char)
		elsif search_down=-1 then
			foundpos=matchfromback(findtext_cmp,s_cmp,from_char)
			if foundpos then
				foundpos-=found_len-1
			end if
		else
			ts("Error: search_down must be 1 or -1, 19. junij 2000 14:02, ponedeljek")
		end if
		--foundpos=match(findtext_cmp,s)		
		--shown("from_char",from_char)
		--shown("foundpos",foundpos)		
	end if
	
	return {foundpos,found_len}
end function
